/*
 * File:          sort_IntegerContainer_Impl.c
 * Symbol:        sort.IntegerContainer-v0.1
 * Symbol Type:   class
 * Babel Version: 0.10.10
 * Description:   Server-side implementation for sort.IntegerContainer
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 * babel-version = 0.10.10
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "sort.IntegerContainer" (version 0.1)
 * 
 * Integer container.
 */

#include "sort_IntegerContainer_Impl.h"

#line 26 "../../../../babel/regression/sort/libC/sort_IntegerContainer_Impl.c"
/* DO-NOT-DELETE splicer.begin(sort.IntegerContainer._includes) */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "sort_Integer.h"
#include "synch_RegOut.h"
/* DO-NOT-DELETE splicer.end(sort.IntegerContainer._includes) */
#line 34 "sort_IntegerContainer_Impl.c"

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_IntegerContainer__load"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_IntegerContainer__load(
  void)
{
#line 48 "../../../../babel/regression/sort/libC/sort_IntegerContainer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.IntegerContainer._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(sort.IntegerContainer._load) */
#line 54 "sort_IntegerContainer_Impl.c"
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_IntegerContainer__ctor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_IntegerContainer__ctor(
  /* in */ sort_IntegerContainer self)
{
#line 66 "../../../../babel/regression/sort/libC/sort_IntegerContainer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.IntegerContainer._ctor) */
  struct sort_IntegerContainer__data *dptr =
    malloc(sizeof(struct sort_IntegerContainer__data));
  if (dptr) {
    dptr->d_elements = NULL;
  }
  sort_IntegerContainer__set_data(self, dptr);
  /* DO-NOT-DELETE splicer.end(sort.IntegerContainer._ctor) */
#line 79 "sort_IntegerContainer_Impl.c"
}

/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_IntegerContainer__dtor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_IntegerContainer__dtor(
  /* in */ sort_IntegerContainer self)
{
#line 90 "../../../../babel/regression/sort/libC/sort_IntegerContainer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.IntegerContainer._dtor) */
  struct sort_IntegerContainer__data *dptr =
    sort_IntegerContainer__get_data(self);
  if (dptr) {
    if (dptr->d_elements) {
      sort_Integer__array_deleteRef(dptr->d_elements);
      dptr->d_elements = NULL;
    }
    free((void *)dptr);
    sort_IntegerContainer__set_data(self, NULL);
  }
  /* DO-NOT-DELETE splicer.end(sort.IntegerContainer._dtor) */
#line 109 "sort_IntegerContainer_Impl.c"
}

/*
 * This sets the container length and pseudo-randomly orders the
 * Integer elements contained.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_IntegerContainer_setLength"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_IntegerContainer_setLength(
  /* in */ sort_IntegerContainer self,
  /* in */ int32_t len)
{
#line 120 "../../../../babel/regression/sort/libC/sort_IntegerContainer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.IntegerContainer.setLength) */
  if (len >= 0) {
    struct sort_IntegerContainer__data *dptr =
      sort_IntegerContainer__get_data(self);
    if (dptr) {
      int32_t i, j;
      if (dptr->d_elements) {
        sort_Integer__array_deleteRef(dptr->d_elements);
      }
      dptr->d_elements = sort_Integer__array_create1d(len);
      for(i = 0; i < len ; ++i ) {
        sort_Integer iptr = sort_Integer__create();
        sort_Integer_setValue(iptr, i+1);
        sort_Integer__array_set1(dptr->d_elements, i, iptr);
        sort_Integer_deleteRef(iptr);
      }
      /* shuffle the list */
      for(i = len - 1; i > 0; --i) {
        j = random() % (i + 1);
        if (j != i) {
          sort_IntegerContainer_swap(self, i, j);
        }
      }
    }
  }
  /* DO-NOT-DELETE splicer.end(sort.IntegerContainer.setLength) */
#line 155 "sort_IntegerContainer_Impl.c"
}

/*
 * Return the number of elements in the container.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_IntegerContainer_getLength"

#ifdef __cplusplus
extern "C"
#endif
int32_t
impl_sort_IntegerContainer_getLength(
  /* in */ sort_IntegerContainer self)
{
#line 162 "../../../../babel/regression/sort/libC/sort_IntegerContainer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.IntegerContainer.getLength) */
  struct sort_IntegerContainer__data *dptr =
    sort_IntegerContainer__get_data(self);
  return (dptr && dptr->d_elements) ? 
    (sort_Integer__array_upper(dptr->d_elements, 0) - 
     sort_Integer__array_lower(dptr->d_elements, 0) + 1)  : 0;
  /* DO-NOT-DELETE splicer.end(sort.IntegerContainer.getLength) */
#line 180 "sort_IntegerContainer_Impl.c"
}

/*
 * Return -1 if element i is less than element j, 0 if element i
 * is equal to element j, or otherwise 1.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_IntegerContainer_compare"

#ifdef __cplusplus
extern "C"
#endif
int32_t
impl_sort_IntegerContainer_compare(
  /* in */ sort_IntegerContainer self,
  /* in */ int32_t i,
  /* in */ int32_t j,
  /* in */ sort_Comparator comp)
{
#line 189 "../../../../babel/regression/sort/libC/sort_IntegerContainer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.IntegerContainer.compare) */
  struct sort_IntegerContainer__data *dptr =
    sort_IntegerContainer__get_data(self);
  int result = 0;
  if (dptr && dptr->d_elements) {
    sort_Integer i1 = sort_Integer__array_get1(dptr->d_elements, i);
    sort_Integer i2 = sort_Integer__array_get1(dptr->d_elements, j);
    result = sort_Comparator_compare(comp,
                                     (sidl_BaseInterface)i1,
                                     (sidl_BaseInterface)i2);
    sort_Integer_deleteRef(i1);
    sort_Integer_deleteRef(i2);
  }
  return result;
  /* DO-NOT-DELETE splicer.end(sort.IntegerContainer.compare) */
#line 217 "sort_IntegerContainer_Impl.c"
}

/*
 * Swap elements i and j.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_IntegerContainer_swap"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_IntegerContainer_swap(
  /* in */ sort_IntegerContainer self,
  /* in */ int32_t i,
  /* in */ int32_t j)
{
#line 222 "../../../../babel/regression/sort/libC/sort_IntegerContainer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.IntegerContainer.swap) */
  struct sort_IntegerContainer__data *dptr =
    sort_IntegerContainer__get_data(self);
  if (dptr && dptr->d_elements) {
    const int32_t len = sort_IntegerContainer_getLength(self);
    if ((i >= 0) && (j >= 0) && (i < len) && (j < len)) {
      sort_Integer i1 = sort_Integer__array_get1(dptr->d_elements, i);
      sort_Integer i2 = sort_Integer__array_get1(dptr->d_elements, j);
      sort_Integer__array_set1(dptr->d_elements, i, i2);
      sort_Integer__array_set1(dptr->d_elements, j, i1);
      sort_Integer_deleteRef(i1);
      sort_Integer_deleteRef(i2);
    }
    else {
      synch_RegOut tracker = synch_RegOut_getInstance();
      fprintf(stderr, "\
sort::IntegerContainer::swap index out of bounds swap(%d, %d) len (%d)\n",
              i, j, len);
      synch_RegOut_forceFailure(tracker);
    }
  }
  /* DO-NOT-DELETE splicer.end(sort.IntegerContainer.swap) */
#line 259 "sort_IntegerContainer_Impl.c"
}

/*
 * Print elements s through e-1
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_IntegerContainer_output"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_IntegerContainer_output(
  /* in */ sort_IntegerContainer self,
  /* in */ int32_t s,
  /* in */ int32_t e)
{
#line 262 "../../../../babel/regression/sort/libC/sort_IntegerContainer_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.IntegerContainer.output) */
  struct sort_IntegerContainer__data *dptr =
    sort_IntegerContainer__get_data(self);
  if (dptr && dptr->d_elements) {
    static const char text[] = "list";
    const size_t bufsize = 14*(e-s) + 6;
    size_t entry_len;
    char *buffer = malloc(bufsize), entry[15];
    int current = sizeof(text)-1;
    synch_RegOut tracker = synch_RegOut_getInstance();
    strcpy(buffer, text);
    while (s < e && (current < bufsize)) {
      sort_Integer i = sort_Integer__array_get1(dptr->d_elements, s++);
      sprintf(entry, " %d", sort_Integer_getValue(i));
      entry_len = strlen(entry);
      if ((current + entry_len) < bufsize) {
        strcpy(buffer + current, entry);
        current += entry_len;
      }
      else {
        current = bufsize + 1;
      }
      sort_Integer_deleteRef(i);
    }
    synch_RegOut_writeComment(tracker, buffer);
    synch_RegOut_deleteRef(tracker);
    free(buffer);
  }
  /* DO-NOT-DELETE splicer.end(sort.IntegerContainer.output) */
#line 308 "sort_IntegerContainer_Impl.c"
}
/* Babel internal methods, Users should not edit below this line. */
struct sidl_ClassInfo__object* 
  impl_sort_IntegerContainer_fconnect_sidl_ClassInfo(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_ClassInfo__connect(url, _ex);
}
char * impl_sort_IntegerContainer_fgetURL_sidl_ClassInfo(struct 
  sidl_ClassInfo__object* obj) {
  return sidl_ClassInfo__getURL(obj);
}
struct sort_Comparator__object* 
  impl_sort_IntegerContainer_fconnect_sort_Comparator(char* url,
  sidl_BaseInterface *_ex) {
  return sort_Comparator__connect(url, _ex);
}
char * impl_sort_IntegerContainer_fgetURL_sort_Comparator(struct 
  sort_Comparator__object* obj) {
  return sort_Comparator__getURL(obj);
}
struct sidl_BaseInterface__object* 
  impl_sort_IntegerContainer_fconnect_sidl_BaseInterface(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_BaseInterface__connect(url, _ex);
}
char * impl_sort_IntegerContainer_fgetURL_sidl_BaseInterface(struct 
  sidl_BaseInterface__object* obj) {
  return sidl_BaseInterface__getURL(obj);
}
struct sort_IntegerContainer__object* 
  impl_sort_IntegerContainer_fconnect_sort_IntegerContainer(char* url,
  sidl_BaseInterface *_ex) {
  return sort_IntegerContainer__connect(url, _ex);
}
char * impl_sort_IntegerContainer_fgetURL_sort_IntegerContainer(struct 
  sort_IntegerContainer__object* obj) {
  return sort_IntegerContainer__getURL(obj);
}
struct sort_Container__object* 
  impl_sort_IntegerContainer_fconnect_sort_Container(char* url,
  sidl_BaseInterface *_ex) {
  return sort_Container__connect(url, _ex);
}
char * impl_sort_IntegerContainer_fgetURL_sort_Container(struct 
  sort_Container__object* obj) {
  return sort_Container__getURL(obj);
}
struct sidl_BaseClass__object* 
  impl_sort_IntegerContainer_fconnect_sidl_BaseClass(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_BaseClass__connect(url, _ex);
}
char * impl_sort_IntegerContainer_fgetURL_sidl_BaseClass(struct 
  sidl_BaseClass__object* obj) {
  return sidl_BaseClass__getURL(obj);
}
