/*
 * File:          sort_QuickSort_Impl.c
 * Symbol:        sort.QuickSort-v0.1
 * Symbol Type:   class
 * Babel Version: 0.10.10
 * Description:   Server-side implementation for sort.QuickSort
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 * babel-version = 0.10.10
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "sort.QuickSort" (version 0.1)
 * 
 * Quick sort
 */

#include "sort_QuickSort_Impl.h"

#line 26 "../../../../babel/regression/sort/libC/sort_QuickSort_Impl.c"
/* DO-NOT-DELETE splicer.begin(sort.QuickSort._includes) */
#include "sort_Container.h"
#include "sort_Counter.h"
#include "sort_Comparator.h"
#include "sidl_String.h"
#include <stdio.h>

/**
 * Choose the middle of the first, middle and last element of the
 * list.  For small lists, return the middle without checking.
 */
static int32_t
choosePivot(sort_Container  elems,
            sort_Comparator comp,
            sort_Counter    cmp,
            int32_t         start,
            int32_t         end)
{
  int32_t pivot = (start + end) >> 1;
  if ((end - start) > 4) {
    int32_t mid = pivot;
    sort_Counter_inc(cmp);
    if (sort_Container_compare(elems, start, mid, comp) <= 0) {
      sort_Counter_inc(cmp);
      if (sort_Container_compare(elems, mid, end - 1, comp) > 0) {
        sort_Counter_inc(cmp);
        if (sort_Container_compare(elems, start, end - 1, comp) < 0) {
          pivot = end - 1;
        }
        else {
          pivot = start;
        }
      }
    }
    else {
      sort_Counter_inc(cmp);
      if (sort_Container_compare(elems, mid, end - 1, comp) < 0) {
        sort_Counter_inc(cmp);
        if (sort_Container_compare(elems, start, end - 1, comp) > 0) {
          pivot = end - 1;
        }
        else {
          pivot = start;
        }
      }
    }
  }
  return pivot;
}

static void 
quickSort(sort_Container  elems,
          sort_Comparator comp,
          sort_Counter    cmp,
          sort_Counter    swp,
          int32_t         start,
          int32_t         end)
{
  if ((end - start) > 1) {
    int32_t pivot = choosePivot(elems, comp, cmp, start, end);
    int32_t i = start;
    int32_t j = end;
    if (pivot != start) {
      sort_Counter_inc(swp);
      sort_Container_swap(elems, start, pivot);
    }
    for(;;) {
      do {
        --j;
        sort_Counter_inc(cmp);
      } while (sort_Container_compare(elems, start, j, comp) < 0);
      while (++i < j) {
        sort_Counter_inc(cmp);
        if (sort_Container_compare(elems, start, i, comp) < 0) break;
      }
      if (i >= j) break;
      sort_Counter_inc(swp);
      sort_Container_swap(elems, i, j);
    }
    if (j != start) {
      sort_Counter_inc(swp);
      sort_Container_swap(elems, start, j);
    }
    quickSort(elems, comp, cmp, swp, start, j);
    quickSort(elems, comp, cmp, swp, j + 1, end);
  }
}
/* DO-NOT-DELETE splicer.end(sort.QuickSort._includes) */
#line 115 "sort_QuickSort_Impl.c"

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort__load"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_QuickSort__load(
  void)
{
#line 129 "../../../../babel/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(sort.QuickSort._load) */
#line 135 "sort_QuickSort_Impl.c"
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort__ctor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_QuickSort__ctor(
  /* in */ sort_QuickSort self)
{
#line 147 "../../../../babel/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort._ctor) */
  /* Insert the implementation of the constructor method here... */
  /* DO-NOT-DELETE splicer.end(sort.QuickSort._ctor) */
#line 155 "sort_QuickSort_Impl.c"
}

/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort__dtor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_QuickSort__dtor(
  /* in */ sort_QuickSort self)
{
#line 166 "../../../../babel/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort._dtor) */
  /* Insert the implementation of the destructor method here... */
  /* DO-NOT-DELETE splicer.end(sort.QuickSort._dtor) */
#line 176 "sort_QuickSort_Impl.c"
}

/*
 * Sort elements using Quick Sort.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort_sort"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_QuickSort_sort(
  /* in */ sort_QuickSort self,
  /* in */ sort_Container elems,
  /* in */ sort_Comparator comp)
{
#line 187 "../../../../babel/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort.sort) */
  const int32_t num = sort_Container_getLength(elems);
  sort_Counter cmp = sort_QuickSort_getCompareCounter(self);
  sort_Counter swp = sort_QuickSort_getSwapCounter(self);
  quickSort(elems, comp, cmp, swp, 0, num);
  sort_Counter_deleteRef(cmp);
  sort_Counter_deleteRef(swp);
  /* DO-NOT-DELETE splicer.end(sort.QuickSort.sort) */
#line 204 "sort_QuickSort_Impl.c"
}

/*
 * Return quick sort.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_QuickSort_getName"

#ifdef __cplusplus
extern "C"
#endif
char*
impl_sort_QuickSort_getName(
  /* in */ sort_QuickSort self)
{
#line 211 "../../../../babel/regression/sort/libC/sort_QuickSort_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.QuickSort.getName) */
  return sidl_String_strdup("Quick sort");
  /* DO-NOT-DELETE splicer.end(sort.QuickSort.getName) */
#line 225 "sort_QuickSort_Impl.c"
}
/* Babel internal methods, Users should not edit below this line. */
struct sort_QuickSort__object* 
  impl_sort_QuickSort_fconnect_sort_QuickSort(char* url,
  sidl_BaseInterface *_ex) {
  return sort_QuickSort__connect(url, _ex);
}
char * impl_sort_QuickSort_fgetURL_sort_QuickSort(struct 
  sort_QuickSort__object* obj) {
  return sort_QuickSort__getURL(obj);
}
struct sort_SortingAlgorithm__object* 
  impl_sort_QuickSort_fconnect_sort_SortingAlgorithm(char* url,
  sidl_BaseInterface *_ex) {
  return sort_SortingAlgorithm__connect(url, _ex);
}
char * impl_sort_QuickSort_fgetURL_sort_SortingAlgorithm(struct 
  sort_SortingAlgorithm__object* obj) {
  return sort_SortingAlgorithm__getURL(obj);
}
struct sidl_ClassInfo__object* 
  impl_sort_QuickSort_fconnect_sidl_ClassInfo(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_ClassInfo__connect(url, _ex);
}
char * impl_sort_QuickSort_fgetURL_sidl_ClassInfo(struct 
  sidl_ClassInfo__object* obj) {
  return sidl_ClassInfo__getURL(obj);
}
struct sort_Comparator__object* 
  impl_sort_QuickSort_fconnect_sort_Comparator(char* url,
  sidl_BaseInterface *_ex) {
  return sort_Comparator__connect(url, _ex);
}
char * impl_sort_QuickSort_fgetURL_sort_Comparator(struct 
  sort_Comparator__object* obj) {
  return sort_Comparator__getURL(obj);
}
struct sidl_BaseInterface__object* 
  impl_sort_QuickSort_fconnect_sidl_BaseInterface(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_BaseInterface__connect(url, _ex);
}
char * impl_sort_QuickSort_fgetURL_sidl_BaseInterface(struct 
  sidl_BaseInterface__object* obj) {
  return sidl_BaseInterface__getURL(obj);
}
struct sort_Container__object* 
  impl_sort_QuickSort_fconnect_sort_Container(char* url,
  sidl_BaseInterface *_ex) {
  return sort_Container__connect(url, _ex);
}
char * impl_sort_QuickSort_fgetURL_sort_Container(struct 
  sort_Container__object* obj) {
  return sort_Container__getURL(obj);
}
struct sort_Counter__object* impl_sort_QuickSort_fconnect_sort_Counter(char* 
  url, sidl_BaseInterface *_ex) {
  return sort_Counter__connect(url, _ex);
}
char * impl_sort_QuickSort_fgetURL_sort_Counter(struct sort_Counter__object* 
  obj) {
  return sort_Counter__getURL(obj);
}
struct sidl_BaseClass__object* 
  impl_sort_QuickSort_fconnect_sidl_BaseClass(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_BaseClass__connect(url, _ex);
}
char * impl_sort_QuickSort_fgetURL_sidl_BaseClass(struct 
  sidl_BaseClass__object* obj) {
  return sidl_BaseClass__getURL(obj);
}
