/*
 * File:          sort_SortingAlgorithm_Impl.c
 * Symbol:        sort.SortingAlgorithm-v0.1
 * Symbol Type:   class
 * Babel Version: 0.10.10
 * Description:   Server-side implementation for sort.SortingAlgorithm
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 * babel-version = 0.10.10
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "sort.SortingAlgorithm" (version 0.1)
 * 
 * An abstract sorting algorithm.
 */

#include "sort_SortingAlgorithm_Impl.h"

#line 26 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
/* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._includes) */
#include <stdlib.h>
#include "sort_SimpleCounter.h"
/* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._includes) */
#line 31 "sort_SortingAlgorithm_Impl.c"

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__load"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_SortingAlgorithm__load(
  void)
{
#line 45 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._load) */
#line 51 "sort_SortingAlgorithm_Impl.c"
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__ctor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_SortingAlgorithm__ctor(
  /* in */ sort_SortingAlgorithm self)
{
#line 63 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._ctor) */
  struct sort_SortingAlgorithm__data *dptr = 
    malloc(sizeof(struct sort_SortingAlgorithm__data ));
  if (dptr) {
    dptr->d_swp = sort_Counter__cast(sort_SimpleCounter__create());
    dptr->d_cmp = sort_Counter__cast(sort_SimpleCounter__create());
  }
  sort_SortingAlgorithm__set_data(self, dptr);
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._ctor) */
#line 77 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__dtor"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_SortingAlgorithm__dtor(
  /* in */ sort_SortingAlgorithm self)
{
#line 88 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._dtor) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  if (dptr) {
    sort_Counter_deleteRef(dptr->d_swp);
    dptr->d_swp = NULL;
    sort_Counter_deleteRef(dptr->d_cmp);
    dptr->d_cmp = NULL;
    free((void *)dptr);
  }
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._dtor) */
#line 106 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Return the comparison counter.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm_getCompareCounter"

#ifdef __cplusplus
extern "C"
#endif
sort_Counter
impl_sort_SortingAlgorithm_getCompareCounter(
  /* in */ sort_SortingAlgorithm self)
{
#line 115 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm.getCompareCounter) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  sort_Counter result = NULL;
  if (dptr) {
    sort_Counter_addRef(dptr->d_cmp);
    result = dptr->d_cmp;
  }
  return result;
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm.getCompareCounter) */
#line 134 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Return the swap counter.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm_getSwapCounter"

#ifdef __cplusplus
extern "C"
#endif
sort_Counter
impl_sort_SortingAlgorithm_getSwapCounter(
  /* in */ sort_SortingAlgorithm self)
{
#line 141 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm.getSwapCounter) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  sort_Counter result = NULL;
  if (dptr) {
    sort_Counter_addRef(dptr->d_swp);
    result = dptr->d_swp;
  }
  return result;
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm.getSwapCounter) */
#line 162 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Reset the comparison and swap counter.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm_reset"

#ifdef __cplusplus
extern "C"
#endif
void
impl_sort_SortingAlgorithm_reset(
  /* in */ sort_SortingAlgorithm self)
{
#line 167 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm.reset) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  if (dptr) {
    sort_Counter_reset(dptr->d_swp);
    sort_Counter_reset(dptr->d_cmp);
  }
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm.reset) */
#line 188 "sort_SortingAlgorithm_Impl.c"
}
/* Babel internal methods, Users should not edit below this line. */
struct sort_SortingAlgorithm__object* 
  impl_sort_SortingAlgorithm_fconnect_sort_SortingAlgorithm(char* url,
  sidl_BaseInterface *_ex) {
  return sort_SortingAlgorithm__connect(url, _ex);
}
char * impl_sort_SortingAlgorithm_fgetURL_sort_SortingAlgorithm(struct 
  sort_SortingAlgorithm__object* obj) {
  return sort_SortingAlgorithm__getURL(obj);
}
struct sidl_ClassInfo__object* 
  impl_sort_SortingAlgorithm_fconnect_sidl_ClassInfo(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_ClassInfo__connect(url, _ex);
}
char * impl_sort_SortingAlgorithm_fgetURL_sidl_ClassInfo(struct 
  sidl_ClassInfo__object* obj) {
  return sidl_ClassInfo__getURL(obj);
}
struct sort_Comparator__object* 
  impl_sort_SortingAlgorithm_fconnect_sort_Comparator(char* url,
  sidl_BaseInterface *_ex) {
  return sort_Comparator__connect(url, _ex);
}
char * impl_sort_SortingAlgorithm_fgetURL_sort_Comparator(struct 
  sort_Comparator__object* obj) {
  return sort_Comparator__getURL(obj);
}
struct sidl_BaseInterface__object* 
  impl_sort_SortingAlgorithm_fconnect_sidl_BaseInterface(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_BaseInterface__connect(url, _ex);
}
char * impl_sort_SortingAlgorithm_fgetURL_sidl_BaseInterface(struct 
  sidl_BaseInterface__object* obj) {
  return sidl_BaseInterface__getURL(obj);
}
struct sort_Counter__object* 
  impl_sort_SortingAlgorithm_fconnect_sort_Counter(char* url,
  sidl_BaseInterface *_ex) {
  return sort_Counter__connect(url, _ex);
}
char * impl_sort_SortingAlgorithm_fgetURL_sort_Counter(struct 
  sort_Counter__object* obj) {
  return sort_Counter__getURL(obj);
}
struct sort_Container__object* 
  impl_sort_SortingAlgorithm_fconnect_sort_Container(char* url,
  sidl_BaseInterface *_ex) {
  return sort_Container__connect(url, _ex);
}
char * impl_sort_SortingAlgorithm_fgetURL_sort_Container(struct 
  sort_Container__object* obj) {
  return sort_Container__getURL(obj);
}
struct sidl_BaseClass__object* 
  impl_sort_SortingAlgorithm_fconnect_sidl_BaseClass(char* url,
  sidl_BaseInterface *_ex) {
  return sidl_BaseClass__connect(url, _ex);
}
char * impl_sort_SortingAlgorithm_fgetURL_sidl_BaseClass(struct 
  sidl_BaseClass__object* obj) {
  return sidl_BaseClass__getURL(obj);
}
