/*
 * File:          sidl_rmi_InstanceRegistry_Module.c
 * Symbol:        sidl.rmi.InstanceRegistry-v0.9.3
 * Symbol Type:   class
 * Babel Version: 0.10.10
 * Release:       $Name:  $
 * Revision:      @(#) $Id: $
 * Description:   implement a C extension type for a sidl extendable
 * 
 * Copyright (c) 2000-2002, The Regents of the University of California.
 * Produced at the Lawrence Livermore National Laboratory.
 * Written by the Components Team <components@llnl.gov>
 * All rights reserved.
 * 
 * This file is part of Babel. For more information, see
 * http://www.llnl.gov/CASC/components/. Please read the COPYRIGHT file
 * for Our Notice and the LICENSE file for the GNU Lesser General Public
 * License.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License (as published by
 * the Free Software Foundation) version 2.1 dated February 1999.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
 * conditions of the GNU Lesser General Public License for more details.
 * 
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 * babel-version = 0.10.10
 */

/*
 * THIS CODE IS AUTOMATICALLY GENERATED BY THE BABEL
 * COMPILER. DO NOT EDIT THIS!
 * 
 * This file contains the implementation of a Python C
 * extension type (i.e. a Python type implemented in C).
 * This extension type provides Python interface to the
 * sidl type sidl.rmi.InstanceRegistry.
 */


/**
 * Symbol "sidl.rmi.InstanceRegistry" (version 0.9.3)
 * 
 * This singleton class is implemented by Babel's runtime for RMI libraries to 
 * invoke methods on server objects.  It is assumed that the RMI library
 * has a self-describing stream of data, but the data may be reordered
 * from the natural argument list.
 * 
 * 
 * In the case of the RMI library receiving a self-describing stream
 * and wishing to invoke a method on a class... the RMI library would 
 * make a sequence of calls like:
 * 
 *       sidl_BaseClass bc = sidl_rmi_InstanceRegistry_getInstance( "instanceID" );
 *       sidl_rmi_TypeMap inArgs = sidl_rmi_TypeMap__create();
 *       
 *       sidl_rmi_TypeMap_putDouble( inArgs, "input_val" , 2.0 );
 *       sidl_rmi_TypeMap_putString( inArgs, "input_str", "Hello" );
 *       ...
 *       sidl_rmi_TypeMap ourArgs = sidl_BaseClass_execMethod( bc, "methodName" , t );
 * 
 *       sidl_rmi_Response_unpackBool( i, "_retval", &succeeded );
 *       sidl_rmi_Response_unpackFloat( i, "output_val", &f );
 */
#define sidl_rmi_InstanceRegistry_INTERNAL 1
#include "sidl_rmi_InstanceRegistry_Module.h"
#ifndef included_sidl_rmi_InstanceRegistry_IOR_h
#include "sidl_rmi_InstanceRegistry_IOR.h"
#endif
#include "sidlObjA.h"
#include "sidlPyArrays.h"
#include "Numeric/arrayobject.h"
#ifndef included_sidl_Loader_h
#include "sidl_Loader.h"
#endif
#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
#ifndef included_sidl_interface_IOR_h
#include "sidl_interface_IOR.h"
#endif
#include "sidl_ClassInfo_Module.h"
#include "sidl_rmi_NetworkException_Module.h"
#include "sidl_BaseInterface_Module.h"
#include "sidl_BaseClass_Module.h"
#include <stdlib.h>
#include <string.h>

staticforward PyTypeObject _sidl_rmi_InstanceRegistryType;

static struct sidl_rmi_InstanceRegistry__sepv *_sepv = NULL;

static const struct sidl_rmi_InstanceRegistry__external *_implEPV = NULL;

static PyObject *
pStub_InstanceRegistry_getInstance(PyObject *_ignored, PyObject *_args,       \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  char* instanceID = NULL;
  struct sidl_BaseInterface__object *_exception = NULL;
  static char *_kwlist[] = {
    "instanceID",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict, 
    "z", _kwlist,
    &instanceID);
  if (_okay) {
    struct sidl_BaseClass__object* _return = NULL;
    _return = (*(_sepv->f_getInstance))(instanceID, &_exception);
    if (_exception) {
      struct sidl_rmi_NetworkException__object *_ex0;
      if ((_ex0 = (struct sidl_rmi_NetworkException__object *)
        sidl_PyExceptionCast(_exception, "sidl.rmi.NetworkException")))
      {
        PyObject *obj = sidl_rmi_NetworkException__wrap(_ex0);
        PyObject *_args = PyTuple_New(1);
        PyTuple_SetItem(_args, 0, obj);
        obj = PyObject_CallObject(sidl_rmi_NetworkException__type, _args);
        PyErr_SetObject(sidl_rmi_NetworkException__type, obj);
        Py_XDECREF(_args);
      }
    }
    else {
      _return_value = Py_BuildValue(
        "O&",
        (void *)sidl_BaseClass__wrap, _return);
    }
  }
  return _return_value;
}

static PyObject *
pStub_InstanceRegistry_registerInstance(PyObject *_ignored, PyObject *_args,  \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  struct sidl_BaseClass__object* instance = NULL;
  struct sidl_BaseInterface__object *_exception = NULL;
  static char *_kwlist[] = {
    "instance",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict, 
    "O&", _kwlist,
    (void *)sidl_BaseClass__convert, &instance);
  if (_okay) {
    char* _return = NULL;
    _return = (*(_sepv->f_registerInstance))(instance, &_exception);
    if (_exception) {
      struct sidl_rmi_NetworkException__object *_ex0;
      if ((_ex0 = (struct sidl_rmi_NetworkException__object *)
        sidl_PyExceptionCast(_exception, "sidl.rmi.NetworkException")))
      {
        PyObject *obj = sidl_rmi_NetworkException__wrap(_ex0);
        PyObject *_args = PyTuple_New(1);
        PyTuple_SetItem(_args, 0, obj);
        obj = PyObject_CallObject(sidl_rmi_NetworkException__type, _args);
        PyErr_SetObject(sidl_rmi_NetworkException__type, obj);
        Py_XDECREF(_args);
      }
    }
    else {
      _return_value = Py_BuildValue(
        "z",
        _return);
    }
    sidl_BaseClass_deref(instance);
    free((void *)_return);
  }
  return _return_value;
}

static PyObject *
pStub_InstanceRegistry_removeInstance(PyObject *_ignored, PyObject *_args,    \
  PyObject *_kwdict) {
  PyObject *_return_value = NULL;
  char* instanceID = NULL;
  struct sidl_BaseInterface__object *_exception = NULL;
  static char *_kwlist[] = {
    "instanceID",
    NULL
  };
  const int _okay = PyArg_ParseTupleAndKeywords(
    _args, _kwdict, 
    "z", _kwlist,
    &instanceID);
  if (_okay) {
    struct sidl_BaseClass__object* _return = NULL;
    _return = (*(_sepv->f_removeInstance))(instanceID, &_exception);
    if (_exception) {
      struct sidl_rmi_NetworkException__object *_ex0;
      if ((_ex0 = (struct sidl_rmi_NetworkException__object *)
        sidl_PyExceptionCast(_exception, "sidl.rmi.NetworkException")))
      {
        PyObject *obj = sidl_rmi_NetworkException__wrap(_ex0);
        PyObject *_args = PyTuple_New(1);
        PyTuple_SetItem(_args, 0, obj);
        obj = PyObject_CallObject(sidl_rmi_NetworkException__type, _args);
        PyErr_SetObject(sidl_rmi_NetworkException__type, obj);
        Py_XDECREF(_args);
      }
    }
    else {
      _return_value = Py_BuildValue(
        "O&",
        (void *)sidl_BaseClass__wrap, _return);
    }
  }
  return _return_value;
}

static int
sidl_rmi_InstanceRegistry_createCast(PyObject *self, PyObject *args,          \
  PyObject *kwds) {
  struct sidl_rmi_InstanceRegistry__object *optarg = NULL;
  static char *_kwlist[] = { "sobj", NULL };
  int _okay = PyArg_ParseTupleAndKeywords(args, kwds, "|O&", _kwlist,         \
    (void *)sidl_rmi_InstanceRegistry__convert, &optarg);
  if (_okay) {
    if (!optarg) {
      optarg = (*(_implEPV->createObject))();
    }
    return sidl_Object_Init(
      (SPObject *)self,
      (struct sidl_BaseInterface__object *)optarg,
      sidl_PyStealRef);
  }
  return -1;
}

static PyMethodDef _InstanceRegistryModuleMethods[] = {
  { "getInstance", (PyCFunction)pStub_InstanceRegistry_getInstance,
  (METH_VARARGS | METH_KEYWORDS),
"\
getInstance(in string instanceID)\n\
RETURNS\n\
   (sidl.BaseClass _return)\n\
RAISES\n\
    sidl.rmi.NetworkException\n\
\n\
\
returns a handle to the class based on the unique string"
   },
  { "registerInstance", (PyCFunction)pStub_InstanceRegistry_registerInstance,
  (METH_VARARGS | METH_KEYWORDS),
"\
registerInstance(in sidl.BaseClass instance)\n\
RETURNS\n\
   (string _return)\n\
RAISES\n\
    sidl.rmi.NetworkException\n\
\n\
\
register an instance of a class\n\
 the registry will return a string guaranteed to be unique for\n\
 the lifetime of the process"
   },
  { "removeInstance", (PyCFunction)pStub_InstanceRegistry_removeInstance,
  (METH_VARARGS | METH_KEYWORDS),
"\
removeInstance(in string instanceID)\n\
RETURNS\n\
   (sidl.BaseClass _return)\n\
RAISES\n\
    sidl.rmi.NetworkException\n\
\n\
\
returns a handle to the class based on the unique string\n\
and removes the instance from the table.  "
   },
  { NULL, NULL }
};

static PyMethodDef _InstanceRegistryObjectMethods[] = {
  { NULL, NULL }
};

static PyTypeObject _sidl_rmi_InstanceRegistryType = {
  PyObject_HEAD_INIT(NULL)
  0,      /* ob_size */
  "sidl.rmi.InstanceRegistry.InstanceRegistry", /* tp_name */
  0,      /* tp_basicsize */
  0,      /* tp_itemsize */
  0,      /* tp_dealloc */
  0,      /* tp_print */
  0,      /* tp_getattr */
  0,      /* tp_setattr */
  0,      /* tp_compare */
  0,      /* tp_repr */
  0,      /* tp_as_number */
  0,      /* tp_as_sequence */
  0,      /* tp_as_mapping */
  0,      /* tp_hash  */
  0,      /* tp_call */
  0,      /* tp_str */
  0,      /* tp_getattro */
  0,      /* tp_setattro */
  0,      /* tp_as_buffer */
  Py_TPFLAGS_DEFAULT, /* tp_flags */
  "\
\
This singleton class is implemented by Babel's runtime for RMI libraries to \n\
invoke methods on server objects.  It is assumed that the RMI library\n\
has a self-describing stream of data, but the data may be reordered\n\
from the natural argument list.\n\
\n\
\n\
In the case of the RMI library receiving a self-describing stream\n\
and wishing to invoke a method on a class... the RMI library would \n\
make a sequence of calls like:\n\
\n\
      sidl_BaseClass bc = sidl_rmi_InstanceRegistry_getInstance( \"instanceID\" );\n\
      sidl_rmi_TypeMap inArgs = sidl_rmi_TypeMap__create();\n\
      \n\
      sidl_rmi_TypeMap_putDouble( inArgs, \"input_val\" , 2.0 );\n\
      sidl_rmi_TypeMap_putString( inArgs, \"input_str\", \"Hello\" );\n\
      ...\n\
      sidl_rmi_TypeMap ourArgs = sidl_BaseClass_execMethod( bc, \"methodName\" , t );\n\
\n\
      sidl_rmi_Response_unpackBool( i, \"_retval\", &succeeded );\n\
      sidl_rmi_Response_unpackFloat( i, \"output_val\", &f );", /* tp_doc */
  0,      /* tp_traverse */
  0,       /* tp_clear */
  0,       /* tp_richcompare */
  0,       /* tp_weaklistoffset */
  0,       /* tp_iter */
  0,       /* tp_iternext */
  _InstanceRegistryObjectMethods, /* tp_methods */
  0,       /* tp_members */
  0,       /* tp_getset */
  0,       /* tp_base */
  0,       /* tp_dict */
  0,       /* tp_descr_get */
  0,       /* tp_descr_set */
  0,       /* tp_dictoffset */
  sidl_rmi_InstanceRegistry_createCast,   /* tp_init */
  0,       /* tp_alloc */
  0,       /* tp_new */
};

sidl_rmi_InstanceRegistry__wrap_RETURN
sidl_rmi_InstanceRegistry__wrap sidl_rmi_InstanceRegistry__wrap_PROTO {
  PyObject *result;
  if (sidlobj) {
    result =                                                                  \
      _sidl_rmi_InstanceRegistryType.tp_new(&_sidl_rmi_InstanceRegistryType,  \
      NULL, NULL);
    if (result) {
      if (sidl_Object_Init(
        (SPObject *)result,
        (struct sidl_BaseInterface__object *)(sidlobj),
        sidl_PyStealRef))
      {
        Py_DECREF(result);
        result = NULL;
      }
    }
  }
  else {
    result = Py_None;
    Py_INCREF(result);
  }
  return result;
}

sidl_rmi_InstanceRegistry__weakRef_RETURN
sidl_rmi_InstanceRegistry__weakRef sidl_rmi_InstanceRegistry__weakRef_PROTO {
  PyObject *result;
  if (sidlobj) {
    result =                                                                  \
      _sidl_rmi_InstanceRegistryType.tp_new(&_sidl_rmi_InstanceRegistryType,  \
      NULL, NULL);
    if (result) {
      if (sidl_Object_Init(
        (SPObject *)result,
        (struct sidl_BaseInterface__object *)(sidlobj),
        sidl_PyWeakRef))
      {
        Py_DECREF(result);
        result = NULL;
      }
    }
  }
  else {
    result = Py_None;
    Py_INCREF(result);
  }
  return result;
}

sidl_rmi_InstanceRegistry_deref_RETURN
sidl_rmi_InstanceRegistry_deref sidl_rmi_InstanceRegistry_deref_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_deleteRef))(sidlobj);
  }
}

sidl_rmi_InstanceRegistry__newRef_RETURN
sidl_rmi_InstanceRegistry__newRef sidl_rmi_InstanceRegistry__newRef_PROTO {
  PyObject *result;
  if (sidlobj) {
    result =                                                                  \
      _sidl_rmi_InstanceRegistryType.tp_new(&_sidl_rmi_InstanceRegistryType,  \
      NULL, NULL);
    if (result) {
      if (sidl_Object_Init(
        (SPObject *)result,
        (struct sidl_BaseInterface__object *)(sidlobj),
        sidl_PyNewRef))
      {
        Py_DECREF(result);
        result = NULL;
      }
    }
  }
  else {
    result = Py_None;
    Py_INCREF(result);
  }
  return result;
}

sidl_rmi_InstanceRegistry__addRef_RETURN
sidl_rmi_InstanceRegistry__addRef sidl_rmi_InstanceRegistry__addRef_PROTO {
  if (sidlobj) {
    (*(sidlobj->d_epv->f_addRef))(sidlobj);
  }
}

sidl_rmi_InstanceRegistry_PyType_RETURN
sidl_rmi_InstanceRegistry_PyType sidl_rmi_InstanceRegistry_PyType_PROTO {
  Py_INCREF(&_sidl_rmi_InstanceRegistryType);
  return &_sidl_rmi_InstanceRegistryType;
}

sidl_rmi_InstanceRegistry__convert_RETURN
sidl_rmi_InstanceRegistry__convert sidl_rmi_InstanceRegistry__convert_PROTO {
  *sidlobj = sidl_Cast(obj, "sidl.rmi.InstanceRegistry");
  if (*sidlobj) {
    (*((*sidlobj)->d_epv->f_addRef))(*sidlobj);
  }
  else if (obj != Py_None) {
    PyErr_SetString(PyExc_TypeError, 
      "argument is not a(n) sidl.rmi.InstanceRegistry");
    return 0;
  }
  return 1;
}

static int
_convertPython(void *sidlarray, const int *ind, PyObject *pyobj)
{
  struct sidl_rmi_InstanceRegistry__object *sidlobj;
  if (sidl_rmi_InstanceRegistry__convert(pyobj, &sidlobj)) {
    sidl_interface__array_set((struct sidl_interface__array *)sidlarray,
    ind, (struct sidl_BaseInterface__object *)sidlobj);
    if (sidlobj) {
      sidl_BaseInterface_deleteRef((struct sidl_BaseInterface__object         \
        *)sidlobj);
    }
    return FALSE;
  }
  return TRUE;
}

sidl_rmi_InstanceRegistry__convert_python_array_RETURN
sidl_rmi_InstanceRegistry__convert_python_array                               \
  sidl_rmi_InstanceRegistry__convert_python_array_PROTO {
  int result = 0;
  *sidlarray = NULL;
  if (obj == Py_None) {
    result = TRUE;
  }
  else {
    PyObject *pya = PyArray_FromObject(obj, PyArray_OBJECT, 0, 0);
    if (pya) {
      if (PyArray_OBJECT == ((PyArrayObject *)pya)->descr->type_num) {
        int dimen, lower[SIDL_MAX_ARRAY_DIMENSION],
          upper[SIDL_MAX_ARRAY_DIMENSION],
          stride[SIDL_MAX_ARRAY_DIMENSION];
        if (sidl_array__extract_python_info
          (pya, &dimen, lower, upper, stride))
        {
            *sidlarray = (struct                                              \
              sidl_rmi_InstanceRegistry__array*)sidl_interface__array_createRow
            (dimen, lower, upper);
          result = sidl_array__convert_python
            (pya, dimen, *sidlarray, _convertPython);
          if (*sidlarray && !result) {
            sidl_interface__array_deleteRef(
              (struct  sidl_interface__array *)*sidlarray);
            *sidlarray = NULL;
          }
        }
      }
      Py_DECREF(pya);
    }
  }
  return result;
}

static int
_convertSIDL(void *sidlarray, const int *ind, PyObject **dest)
{
  struct sidl_rmi_InstanceRegistry__object *sidlobj = (struct                 \
    sidl_rmi_InstanceRegistry__object*)
  sidl_interface__array_get((struct sidl_interface__array *)
    sidlarray, ind);
  *dest = sidl_rmi_InstanceRegistry__wrap(sidlobj);
  return (*dest == NULL);
}

sidl_rmi_InstanceRegistry__convert_sidl_array_RETURN
sidl_rmi_InstanceRegistry__convert_sidl_array                                 \
  sidl_rmi_InstanceRegistry__convert_sidl_array_PROTO {
  PyObject *pya = NULL;
  if (sidlarray) {
    const int dimen = sidlArrayDim(sidlarray);
    int i;
    int *lower = (int *)malloc(sizeof(int) * dimen);
    int *upper = (int *)malloc(sizeof(int) * dimen);
    int *numelem = (int *)malloc(sizeof(int) * dimen);
    for(i = 0; i < dimen; ++i) {
      lower[i] = sidlLower(sidlarray, i);
      upper[i] = sidlUpper(sidlarray, i);
      numelem[i] = 1 + upper[i] - lower[i];
    }
    pya = PyArray_FromDims(dimen, numelem, PyArray_OBJECT);
    if (pya) {
      if (!sidl_array__convert_sidl(pya, dimen, lower, upper,
        numelem, sidlarray, _convertSIDL))
      {
        Py_DECREF(pya);
        pya = NULL;
      }
    }
    free(numelem);
    free(upper);
    free(lower);
  }
  else {
    Py_INCREF(Py_None);
    pya = Py_None;
  }
  return pya;
}

void
initInstanceRegistry(void) {
  PyObject *module, *dict, *c_api;
  static void *ExternalAPI[sidl_rmi_InstanceRegistry__API_NUM];
  module = Py_InitModule3("InstanceRegistry", _InstanceRegistryModuleMethods, \
    "\
\
This singleton class is implemented by Babel's runtime for RMI libraries to \n\
invoke methods on server objects.  It is assumed that the RMI library\n\
has a self-describing stream of data, but the data may be reordered\n\
from the natural argument list.\n\
\n\
\n\
In the case of the RMI library receiving a self-describing stream\n\
and wishing to invoke a method on a class... the RMI library would \n\
make a sequence of calls like:\n\
\n\
      sidl_BaseClass bc = sidl_rmi_InstanceRegistry_getInstance( \"instanceID\" );\n\
      sidl_rmi_TypeMap inArgs = sidl_rmi_TypeMap__create();\n\
      \n\
      sidl_rmi_TypeMap_putDouble( inArgs, \"input_val\" , 2.0 );\n\
      sidl_rmi_TypeMap_putString( inArgs, \"input_str\", \"Hello\" );\n\
      ...\n\
      sidl_rmi_TypeMap ourArgs = sidl_BaseClass_execMethod( bc, \"methodName\" , t );\n\
\n\
      sidl_rmi_Response_unpackBool( i, \"_retval\", &succeeded );\n\
      sidl_rmi_Response_unpackFloat( i, \"output_val\", &f );"
  );
  dict = PyModule_GetDict(module);
  ExternalAPI[sidl_rmi_InstanceRegistry__wrap_NUM] =                          \
    (void*)sidl_rmi_InstanceRegistry__wrap;
  ExternalAPI[sidl_rmi_InstanceRegistry__convert_NUM] =                       \
    (void*)sidl_rmi_InstanceRegistry__convert;
  ExternalAPI[sidl_rmi_InstanceRegistry__convert_python_array_NUM] =          \
    (void*)sidl_rmi_InstanceRegistry__convert_python_array;
  ExternalAPI[sidl_rmi_InstanceRegistry__convert_sidl_array_NUM] =            \
    (void*)sidl_rmi_InstanceRegistry__convert_sidl_array;
  ExternalAPI[sidl_rmi_InstanceRegistry__weakRef_NUM] =                       \
    (void*)sidl_rmi_InstanceRegistry__weakRef;
  ExternalAPI[sidl_rmi_InstanceRegistry_deref_NUM] =                          \
    (void*)sidl_rmi_InstanceRegistry_deref;
  ExternalAPI[sidl_rmi_InstanceRegistry__newRef_NUM] =                        \
    (void*)sidl_rmi_InstanceRegistry__newRef;
  ExternalAPI[sidl_rmi_InstanceRegistry__addRef_NUM] =                        \
    (void*)sidl_rmi_InstanceRegistry__addRef;
  ExternalAPI[sidl_rmi_InstanceRegistry_PyType_NUM] =                         \
    (void*)sidl_rmi_InstanceRegistry_PyType;
  import_SIDLObjA();
  if (PyErr_Occurred()) {
    Py_FatalError("Error importing sidlObjA module.");
  }
  c_api = PyCObject_FromVoidPtr((void *)ExternalAPI, NULL);
  PyDict_SetItemString(dict, "_C_API", c_api);
  Py_XDECREF(c_api);
  import_SIDLPyArrays();
  if (PyErr_Occurred()) {
    Py_FatalError("Error importing sidlPyArrays module.");
  }
  import_array();
  if (PyErr_Occurred()) {
    Py_FatalError("Error importing Numeric Python module.");
  }
  sidl_BaseClass__import();
  _sidl_rmi_InstanceRegistryType.tp_base = sidl_BaseClass_PyType();
  _sidl_rmi_InstanceRegistryType.tp_bases = PyTuple_New(1);
  PyTuple_SetItem(_sidl_rmi_InstanceRegistryType.tp_bases,0,                  \
    (PyObject *)sidl_BaseClass_PyType());
  if (PyType_Ready(&_sidl_rmi_InstanceRegistryType) < 0) {
    PyErr_Print();
    fprintf(stderr, "PyType_Ready on sidl.rmi.InstanceRegistry failed.\n");
    return;
  }
  Py_INCREF(&_sidl_rmi_InstanceRegistryType);
  PyDict_SetItemString(dict, "InstanceRegistry",                              \
    (PyObject *)&_sidl_rmi_InstanceRegistryType);
  sidl_rmi_NetworkException__import();
  sidl_BaseInterface__import();
  sidl_ClassInfo__import();
  _implEPV = sidl_rmi_InstanceRegistry__externals();
  if (_implEPV) {
    _sepv = (*_implEPV->getStaticEPV)();
    if (PyErr_Occurred()) {
      Py_FatalError("Cannot initialize Python module                          \
        sidl.rmi.InstanceRegistry.");
    }
  }
  else {
    Py_FatalError("Cannot load implementation for sidl class                  \
      sidl.rmi.InstanceRegistry");
  }
}
